--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:    09:30:15 12/05/05
-- Design Name:    
-- Module Name:    lu - Behavioral
-- Project Name:   
-- Target Device:  
-- Tool versions:  
-- Description:
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
--------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity lu is
  port (
    funct : in  std_logic_vector(1 downto 0);
    put_left_word, put_right_word : in  std_logic_vector(31 downto 0);
    get_word : out  std_logic_vector(31 downto 0));
end lu;

architecture Behavioral of lu is
  

begin

  process (funct, put_left_word, put_right_word)
  begin  -- process
    case funct is
      when "00" =>
        get_word <= put_left_word and put_right_word;
      when "01" =>
        get_word <= put_left_word or put_right_word;
      when "10" =>
        get_word <= put_left_word xor put_right_word;
      when "11" =>
        get_word <= put_left_word xnor put_right_word;
      when others =>
        get_word <= "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX";
    end case;    
  end process;

end Behavioral;
